<template>
  <v-app>
    <v-main>
      <Landing :loading="!initialized" />
    </v-main>
    <notifications/>
  </v-app>
</template>

<script lang="ts">
import { Component, Provide, Vue, Watch } from 'vue-property-decorator'
import Landing from '@/views/Landing.vue';
import { RootStore } from "@/store";
import { UserModel } from "@/store/modules/user"

@Component({ components: { Landing } })
export default class App extends Vue {
    @Provide("root") root: RootStore = new RootStore()
    @Provide("userModel") userModel = new UserModel(this.root)

    get initialized() {
        return this.root.ipfs.initialized;
    }

    @Watch("initialized")
    private async onNodeInitialized(newVal: boolean) {
        if (newVal) {
            await this.userModel.setUsers();
            this.userModel.initSelf();
        } else {
            this.root.ipfs.init();
        }
    }
}
</script>
